CFPRIME NLCHAR                                                          NLCHAR      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE NLCHAR                                                 NLCHAR      3
CD                                                                      NLCHAR      4
CD    THIS SUBROUTINE IS USED FOR THE MODELLING OF TYPE 1 OR 2 GOVERNOR NLCHAR      5
CD    TO COMPUTE THE NONLINEAR CHARACTERISTIC Y GIVEN VALUE OF X. X AND NLCHAR      6
CD    Y ARE RELATED BY NONLINEAR REALATIONSHIP REPRESENTED BY THREE     NLCHAR      7
CD    PIECEWISE LINEAR RELATION.                                        NLCHAR      8
CD                                                                      NLCHAR      9
      INCLUDE 'CNG3.INS'                                                NLCHAR     10
C                                                                       NLCHAR     11
C                                                                       NLCHAR     12
      IF (((YFA2.LT.1.E-6).AND.(XPN2.GT.0.99)).OR.                      NLCHAR     13
     &((XPN2.LT.1.E-6).AND.(YFA2.GT.0.00)))THEN                         NLCHAR     14
      YOUT=0.0                                                          NLCHAR     15
      RETURN                                                            NLCHAR     16
      ENDIF                                                             NLCHAR     17
      IF (XPIN.GT.XPN2)THEN                                             NLCHAR     18
      YOUT=YFA2+((XPIN-XPN2)*(1.0-YFA2)/(1.0-XPN2))                     NLCHAR     19
      RETURN                                                            NLCHAR     20
      ENDIF                                                             NLCHAR     21
      IF (XPIN.GT.XPN1)THEN                                             NLCHAR     22
      YOUT=YFA1+((XPIN-XPN1)*(YFA2-YFA1)/(XPN2-XPN1))                   NLCHAR     23
      RETURN                                                            NLCHAR     24
      ELSE                                                              NLCHAR     25
      YOUT=XPIN*(YFA1/XPN1)                                             NLCHAR     26
      RETURN                                                            NLCHAR     27
      ENDIF                                                             NLCHAR     28
C                                                                       NLCHAR     29
      END                                                               NLCHAR     30
